<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import { api } from "~/common/constaint";
import _ from "lodash";
var moment = require("moment");

@Component({})
export default class AdminShopProductComponent extends Vue {
  adminProduct = getModule(AdminProductModule, this.$store);

  config = {
    page: 1,
    limit: 24,
    search: "",
  };
  checkGrid = true;
  page = 1;
  totalPage: number = 0;

  selectedAll = false;
  loadingTable = false;
  loading = false;

  listProduct = [];
  listIds = [];
  productId = "";

  dialogDeleteProduct = false;
  dialogDeleteMultipleProduct = false;
  mounted() {
    this.onGetListProduct();
  }

  getGridView() {
    this.checkGrid = true;
  }
  getListView() {
    this.checkGrid = false;
  }
  async onGetListProduct() {
    try {
      this.listProduct = [];
      this.loadingTable = true;
      const response = await this.$api.product.getListAdmin(this.config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogDeleteProduct(productId: string) {
    if (productId) {
      this.productId = productId;
      this.dialogDeleteProduct = true;
    }
  }
  async onDeleteProduct() {
    try {
      this.loading = true;
      await this.$api.product.delete(this.productId);
      this.$pushNotification.success("Deleted product successfully");
      this.dialogDeleteProduct = false;
      this.onGetListProduct();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogDeleteMultipleProduct() {
    if (!this.listIds.length) {
      return this.$pushNotification.error("Please select collection");
    }
    this.dialogDeleteMultipleProduct = true;
  }

  async onDeleteMultipleProduct() {
    try {
      this.loading = true;
      await this.$api.product.deleteList(this.listIds);
      this.$pushNotification.success("Deleted multiple product successfully");
      this.dialogDeleteMultipleProduct = false;
      this.onGetListProduct();
      this.listIds = [];
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onChangeStatus(product: any, status: number) {
    try {
      const payload = {
        productStatus: status,
      };
      await this.$api.product.edit(product._id, payload);
      this.$pushNotification.success("Updated product successfully");
      this.onGetListProduct();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  convertImage(product: any) {
    if (product?.listImageId?.length) {
      return `${api}/${product.listImageId[0].imageUrl}`;
    }
    return "";
  }
  calcPrice(product: any) {
    let price = 0;
    if (product && product.listVariant && product.listVariant.length) {
      return product.listVariant[0].price;
    } else {
      price = product.price;
    }
    return Math.round(price * 100) / 100;
  }
  get findNameProduct() {
    const findProduct: any = this.listProduct.find(
      (product: any) => product._id === this.productId
    );
    if (findProduct) {
      return findProduct.productName;
    }
    return "";
  }

  totalStockProduct(product: any) {
    let num = 0;
    if (product) {
      for (let sanpham of product.listVariant) {
        if (sanpham && sanpham.stock) {
          num += sanpham.stock;
        }
      }
    }
    return num || product.stock;
  }

  onRedirectPage() {
    this.config.page = this.page;
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  onCopySuccess() {
    this.$pushNotification.success("Copied successfully");
  }

  onCopyError() {
    this.$pushNotification.success("Copy failed");
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentProduct];
    } else {
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentProduct.includes(c)
      );
    }
  }

  linkProduct(slug: string) {
    const domain = window.location.host;
    return `${domain}/admin/products/edit/${slug}`;
    // //@ts-ignore
    // let arrLink: any = [];
    // if (window.location.origin.includes("dash")) {
    // 	arrLink = window.location.origin.split("dash.");
    // } else {
    // 	arrLink = window.location.origin.split("admin.");
    // }
    // const link = arrLink.join("");
    // return `${link}/products/${slug}`;
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListProduct();
  }

  @Watch("config.search")
  changedSearch(val: string) {
    if (!val) {
      this.onGetListProduct();
    }
  }
}
</script>

<style lang="scss" scoped>
#admin-shop-product {
  .product-grid {
    @media (min-width: 380px) and (max-width: 600px) {
      max-width: 50%;
      width: 100%;
    }
  }
  .view-bt {
    border: 1px solid #c3c3c3;
    max-width: 130px;
    border-radius: 4px;
  }
}
</style>
